// VoronoiLibTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

extern "C"
{
	#include "voronoi.c"
}

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	string inputFile;				//file containing list of all tiff files
    ifstream inFile;
	string tifFile;					//tiff input file
	string outFile;					//file containing voronoi segments for corresponding tiff input file
	char **arguments;

	if(argc <= 2)
	{
		printf("Please see the usage\n");
		return(0);
	}


	inputFile = argv[1];

	//reading the input file containing the list of all tiff files to be processed
	inFile.open(inputFile.c_str());

	while(inFile)
	{
		//for every TIFF file
		try{

			//copying commandline arguments
			arguments = new char* [argc+1];
			arguments[0] = new char[strlen(argv[0])];
			strcpy(arguments[0], argv[0]);

			//inserting input file name and output filename	
			inFile >> tifFile;
			cout << "Starting File " << tifFile << endl;
			outFile = tifFile;
			outFile.replace(outFile.size()-4, 4, ".txt");

			arguments[1] = new char[tifFile.size()];
			strcpy(arguments[1], tifFile.c_str());
			//arguments[1] = file1;
			arguments[2] = new char[outFile.size()];
			strcpy(arguments[2], outFile.c_str());
			//arguments[2] = file2;
					
			//copying rest of the arguments
			for(int i = 2; i < argc; i++)
			{
				arguments[i+1] = new char[strlen(argv[i])];
				strcpy(arguments[i+1], argv[i]);
			}
			arguments[argc+1] = '\0';

			//Get Voronoi tessellation
			getVoronoiSegments(arguments);

			//freeing arguments
			for(int i = 1; i < argc+1; i++)
			{
//				delete [] arguments[i];
			}
//			delete [] arguments;

			//Getting zone-wise representation of voronoi cells
			//zoneExtraction(inFile, outFile);

		}
		 //Catch any exception derived from the standard C++ exception
		catch(std::exception &ex){
//			 Get the error message
//			 and print to screen
			cout << ex.what();  
		}
//		 Catch all unknown excpetions
		catch(...)
		{
			cout << "Unknown exception!!\n";
		}
	}
	return 0;
}

