static char version_string[]="$Id: chtl.c,v 1.3 1999/10/13 13:14:59 kise Exp $";

/***************************************************************************
*   $Date: 1999/10/13 13:14:59 $                                             *
*   $Revision: 1.3 $                                         *
*   $Author: kise $                                                       *
*                                                                          *
*   chtl.c (convex hull of text-line)                                      *
*   ʸȤ, ˴ޤޤޤϤ褦ˤ             *
*   this program is to generate convex hulls of text-lines                 *
*   as well as to select edges in convex hulls.                            *
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "defs.h"
#include "extern.h"
#include "function.h"


/* 
   ʸϤ
   sides of a convex hull enclosing a text-line
*/
typedef struct tag_Side{
  Coordinate  xs, ys, xe, ye;
  struct tag_Side *next;
} Side;

/* 
   ʸ
   text-line
*/
typedef struct{
  Side   *region;
  Point   gravity;  /* ʸνſ
		       the centroid of a convex hull
		       enclosing a text-line
		       */
  int   vertexnbr;  /* ʸĺο
		       the number of vertices of a convex hull
		       enclosing a text-line
		       */
} TextLine;

TextLine                *textline;
int                     TEXTLINEnbr;     /* ʸθĿ
					    the number of text-lines
					    */

/* Point   points[MAXPOINT]; */

Point *points;
unsigned int current_point_size = INITPOINT;

/*
 *  point_swap
 *  points[]  i ܤ j ܤȤ򴹤ؿ
 */
void point_swap(int i, int j)
{
  Point tmp;

  tmp.x = points[i].x;
  tmp.y = points[i].y;

  points[i].x = points[j].x;
  points[i].y = points[j].y;

  points[j].x = tmp.x;
  points[j].y = tmp.y;
}

/*
 *  signed_area
 *  3 ޤ뻰ѷդ
 */
float signed_area(Point *i, Point *j, Point *k)
{
  return (i->x - k->x) * (j->y - k->y) + (j->x - k->x) * (k->y - i->y);
}

/*
 *  angular_compare
 *  гѽ˥Ȥ뤿δؿ
 */
int angular_compare(const void *a, const void *b)
{
  float triangle = signed_area(&points[0], (Point *)a, (Point *)b);
	
  if(triangle < 0){
    return 1;
  }
  else if(triangle > 0){
    return -1;
  }
  else{
    return 0;
  }
}

/*
 *  init_textline
 *  textline ΰ, Ԥؿ
 *  to allocate and initialize memories for text-lines
 */
void init_textline()
{
  int   i;
	
  TEXTLINEnbr = number_of_seed();

  /* points ΰ */
  points = (Point *)myalloc(sizeof(Point)* INITPOINT);	

  /* textline ΰ */
  textline = (TextLine *)myalloc(sizeof(TextLine) * TEXTLINEnbr);



  /* textline ν */
  for(i = 0; i < TEXTLINEnbr; i++){
    textline[i].region = NULL;
    textline[i].gravity.x = 0.0;
    textline[i].gravity.y = 0.0;
    textline[i].vertexnbr = 0;
  }
}

/*
 *  convex_hull_of_line
 *  ʸȤ, textline ˥åȤؿ
 *  This function is for the generation of
 *  a convex hull of a text-line.
 */
void convex_hull_of_line(int seednum, int textnbr)
{
  int   i;
  Label labnoe;
  int   min = 0, chull;
  int   pointnbr = 0;
  Label label;
  List2 *read;
  Side  *new_element;
  Point tmp;

  labnoe = labnoe_of_seed(seednum);
	
  /* ϢʬΥץ
     points[] ˥åȤ */
  for(i = 0; i < labnoe; i++){
    label = lablist_of_seed(seednum, i);
		
    read = get_sampling_points(label);
		
    while(read != NULL){
      points[pointnbr].x = read->coord.x;
      points[pointnbr].y = read->coord.y;
      pointnbr++;
      if(pointnbr >= current_point_size){
	printf("resizing points\n");
	points = (Point *)myrealloc(points,
				    current_point_size,
				    INCPOINT,
				    sizeof(Point));
	current_point_size+=INCPOINT;
      }
      read = read->next;
    }
  }

  /* points[] Τ, Ǥ⺸ */
  for(i = 1; i < pointnbr; i++){
    if(points[i].x < points[min].x){
      min = i;
    }
  }

  /* Ǥ⺸Ƭ˻äƤ */
  point_swap(0, min);

  /* Ǥ⺸濴Ȥȿײ˥ */
  qsort((void *)(&points[1]), pointnbr - 1, sizeof(Point), angular_compare);

  /* ץ׻ˤޤ魯 */
  for(i = 0; i < pointnbr; i++){
    set_points(i, (int)points[i].x, (int)points[i].y);
  }

  /* 
     chull ĺο */
  chull = ch2d(read_points(pointnbr));

  for(i = 0; i < chull; i++){
    get_vertex(&tmp, i);
    points[i].x = tmp.x;
    points[i].y = tmp.y;
  }
  pointnbr = chull;

  /* ĺο򥻥å */
  textline[textnbr].vertexnbr = pointnbr;

  /* textline ˥å */
  for(i = 1; i < pointnbr; i++){
    /* new_element ΰ */
    new_element = (Side *)myalloc(sizeof(Side));
	
    new_element->xs = (int)points[i-1].x;
    new_element->ys = (int)points[i-1].y;
    new_element->xe = (int)points[i].x;
    new_element->ye = (int)points[i].y;

    new_element->next = textline[textnbr].region;
    textline[textnbr].region = new_element;
  }
  /* new_element ΰ */
  new_element = (Side *)myalloc(sizeof(Side));

  new_element->xs = (int)points[pointnbr-1].x;
  new_element->ys = (int)points[pointnbr-1].y;	
  new_element->xe = (int)points[0].x;
  new_element->ye = (int)points[0].y;

  new_element->next = textline[textnbr].region;
  textline[textnbr].region = new_element;
}

/*
 *  set_gravity
 *  ʸνſ򥻥åȤؿ
 *  function for setting the centroid of
 *  a convex hull of a text-line
 */
void set_gravity()
{
  int   i;
  Side   *read;
  Point   grav;

  for(i = 0; i < TEXTLINEnbr; i++){
    grav.x = 0.0;
    grav.y = 0.0;
    read = textline[i].region;

    while(read != NULL){
      grav.x += (float)read->xs;
      grav.y += (float)read->ys;
      read = read->next;
    }

    textline[i].gravity.x = grav.x / (float)textline[i].vertexnbr;
    textline[i].gravity.y = grav.y / (float)textline[i].vertexnbr;
  }
}

/*
 *  locate
 *  ʸޤޤ뤫ɤȽꤹؿ
 *  function for testing whether or not a convex hull
 *  of a text-line includes a point
 */
int locate(int textnbr, Point *target)
{
  int   i, vertexnbr;
  Side   *read;
  Point  ver1, ver2;

  vertexnbr = textline[textnbr].vertexnbr;
  read = textline[textnbr].region;

  for(i = 0; i < vertexnbr; i++){
    ver1.x = read->xs;
    ver1.y = read->ys;
    ver2.x = read->xe;
    ver2.y = read->ye;
    if(signed_area(target, &ver1, &ver2) < 0.0){
      return OUTSIDE;
    }
    read = read->next;
  }
  return INSIDE;
}

/*
 *  regist_inside
 *  ʸξüޤޤޤϲĤˤ
 *  This function finds edges both of whose end-points
 *  are included in a convex hull of a text-line.
 */
void regist_inside()
{
  int i,j;
  Point   edge1, edge2;
  Label   lab1, lab2;

  for(i = 0; i < NEIGHnbr; i++){
    if(neighbor[i].regist == NOT_REGISTERED){
      lab1 = neighbor[i].lab1;
      lab2 = neighbor[i].lab2;
      edge1.x = (float)component[lab1].xc;
      edge1.y = (float)component[lab1].yc;
      edge2.x = (float)component[lab2].xc;
      edge2.y = (float)component[lab2].yc;
      for(j = 0; j < TEXTLINEnbr; j++){
	if((INSIDE == locate(j, &edge1))&&(INSIDE == locate(j, &edge2))){
	  neighbor[i].regist = REGISTERED;
	  break;
	}
      }
    }
  }
}

/*
 *  output_textline
 *  Ѵؿ
 */
void output_textline()
{
  int   i;
  Side   *read;

  for(i = 0; i < TEXTLINEnbr; i++){
    read = textline[i].region;

    while(read != NULL){
      fprintf(ofp,"%d %d %d %d\n",
	      read->xs, read->xe, read->ys, read->ye);
      read = read->next;
    }
  }
}
