/*
   $Id: const.h,v 1.3 1999/10/15 12:36:21 kise Exp $
   $Date: 1999/10/15 12:36:21 $
   $Revision: 1.3 $
   $Author: kise $
*/

#ifndef LABEL_H_INCLUDED_
#define LABEL_H_INCLUDED_
#ifndef NULL
#define NULL	0
#endif

#define YES		1
#define NO		0
#define REGISTERED      1
#define NOT_REGISTERED  0
#define START           1
#define END             0
#define MIDDLE          2
#define INSIDE          1
#define OUTSIDE         0
#define OUT             1
#define IN              0

#define	BYTE		8       /* [bit] */
#define	BLACK		1
#define WHITE		0
#define RIGHTANGLE	90.0
#define M_PI		3.14159265358979323846

/* initial size and increments */
#define INITPIXEL	5000000  /* initial size of black pixels */
#define INCPIXEL        100000   /* its increments */

#define INITLABEL	5000     /* initial size of connected components */
#define INCLABEL	1000     /* its increments */

#define SITE_BOX        4000

#define INITNEIGHBOR	50000    /* initial size of the array "neighbor" */
#define INCNEIGHBOR     10000    /* its increments */

#define INITLINE        50000    /* initial size of the array "lineseg" */
#define INCLINE         10000    /* its increments */

#define INITSEED        1000     /* initial size of the array "seed" */
#define INCSEED         500      /* its increments */

#define INITID          300      /* initial size of the array "idlist"
				    in the structure "Seed" */
#define INCID           50       /* its increments */

#define INITSEEDELM     1000     /* initial size of the array "lablist"
				    in the structure "Seed" */
#define INCSEEDELM      100      /* its increments */

#define INITPOINT       2000     /* initial size of the array "points"
				    in the file chtl.c */
#define INCPOINT        1000     /* its increments */

/* MAX valures */
#define UNSIGNED_MAX    0xFFFFFFFF /* unsigned int κ */
#define NOLABEL		0xFFFF     /* unsigned short κ */
#define LABELMAX        NOLABEL

/* default values of parameters */
#define SAMPLE_RATE     7
#define T_AREA          0.025 /* ɱĹѤκǾ */
#define T_DIA           0.1   /* ɱĹľ¤κǾ */
#define ANGLE_FILTER    400.0 /* ɤΥե륿󥰤 */
#define DIST_FILTER     50.0  /* ɤΥե륿󥰤 */
#define C_THETA         50    /* ɤαĹȽΦ */
#define C_DIST          1600  /* ɤαĹȽ distance  */
#define LOOPTIMES       10    /* ɤαĹȽΥ롼ײ */
#define MINNOE          3
#define APTNBR          2
#define	NOISE_MAX	25   /* A connected comonent whose area is
				less than NOISE_MAX is deleted as a noise */
#define FREQ_RATE	0.25
#define SMWIND          2    /* for smoothing of frequency distribution
				of the distance between connected components:
				the size of a smoothing window is 
				2 * SMWIND + 1 */

/* for sweep2 */
#define LE		0
#define RE		1
#define DELETED		-2

/* ܥΥդüα
   An end point of a Voronoi edge is on the border of an image,
   its sitenbr is FRAME (erase.c, output.c) */
#define	FRAME		-1

/* for hash tables */
#define M1		10007	/* a prime number */
#define M2		3	/* a prime number */
#define NIL		0
#define NODATA		-1

/* for output of voronoi edges */
#define OUTPUT		1
#define NO_OUTPUT	0

/* for 2dch.c */
#define N_CH_POINTS     60000
#define SMALL           0

#endif /* LABEL_H_INCLUDED_ */
