static char version_string[]="$Id: main.c,v 1.5 1999/10/15 12:36:21 kise Exp $";
/*
   $Date: 1999/10/15 12:36:21 $
   $Revision: 1.5 $
   $Author: kise $
   main.c
   ᥤץ
   main program for the line extraction
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "const.h"
#include "defs.h"
#include "function.h"

BlackPixel 	*bpx;		/* ǤκɸȤΥ٥
				   coordinates and a label of a black pixel */
Component       *component;     /* Ϣʬνſɸ
				   the area and the centroid
				   of a connected component(CC) */
Neighborhood	*neighbor;	/* Ϣʬ֤ħ
				   features between CC's */
LineSegment	*lineseg;	/* κɸȥ٥
				   coordinates of line segments*/
HashTable	*hashtable[M1+M2];/* ϢʬΥ٥Ф
				   ϥåɽ
				   the hash table for labels of CC's */
EndPoint	*endp;		/* ʬü
				   Endpoints of line segments */
NumPixel	BPnbr;		/* Ǥο
				   # of black pixels */
Label	        LABELnbr;	/* Ϣʬ
				   # of CC's */
unsigned int	NEIGHnbr;	/* ܤϢʬȤο
				   # of pairs of neighboring CC's */
unsigned int    LINEnbr;	/* ΥꥢܥΥդ
				   ʬο
				   # of line segments in the area Voronoi
				   diagram before deletion */
unsigned int	Enbr;		/* ܥΥդϢ
				   ʬȤο
				   # of pairs of CCs whose Voronoi edges
				   are deleted */
long		SiteMax;	/* ܥΥֹκ
				   max. # of Voronoi points */

int		noise_max = NOISE_MAX;	   /* Ϣʬβǿ */
int		sample_rate = SAMPLE_RATE; /* פǥץ󥰤
					       */
float		freq_rate = FREQ_RATE;
float           angle_filter = ANGLE_FILTER;
float           dist_filter = DIST_FILTER;

unsigned int	sample_pix;	/* ץ󥰤줿ǿ
				   # of sampled pixels */
unsigned int	point_edge;	/* ܥΥդܿ
				   # of Voronoi edges in the point
				   Voronoi diagram */
unsigned int	edge_nbr;	/* ΥꥢܥΥդ
				   ʬܿ
				   # of line segments after deletion */
//int             *area;          /* ٥ln Ϣʬ
//				   the area of a CC whose label is ln */

#ifdef TIME
float		b_s_time=0.0;
float           v_time  =0.0;
float           e_time  =0.0;
float           o_time  =0.0;
float           c_time  =0.0;     /* , , ľ¤η׻ˤ */
float           etc_time=0.0;
#endif /* TIME */

float	xmin, xmax, ymin, ymax, deltax, deltay;

struct	Site		*sites;
int			nsites;
int			siteidx;
int			sqrt_nsites;
int			nvertices;
struct 	Freelist 	sfl;
struct	Site		*bottomsite;

int 			nedges;
struct	Freelist 	efl;

struct  Freelist	hfl;
struct	Halfedge	*ELleftend, *ELrightend;
int 			ELhashsize;
struct	Halfedge	**ELhash;

int 			PQhashsize;
struct	Halfedge 	*PQhash;
int 			PQcount;
int 			PQmin;

/* the size of a smoothing window*/
int    smwind               = SMWIND;

/* ɤξȽ
   parameters for the selection of seeds */
float    c_theta            = C_THETA;
float    c_dist             = C_DIST;
int      looptimes          = LOOPTIMES;
float    t_area             = T_AREA;
float    t_dia              = T_DIA;
int      aptnbr             = APTNBR;
int      minnoe             = MINNOE;
char     cdist_is_auto      = NO;

char     output_convexhull  = NO; /* output is convex hulls */
char     in_ch_line         = NO; /* output is all edges in
				     convex hulls of text-lines */
char     output_points      = NO;
char     output_pvor        = NO;
char     output_avor        = NO;
char     output_ng          = NO;
char     output_seed        = NO;
char     display_parameters = NO;

FILE		*ofp;

int main(int argc, char **argv) 
{
  int 		i;
  int           ifargc, ofargc;
  ImageData	imgd1;

#ifdef TIME
  clock_t		start,end;
#endif

#ifdef TIME
  start = clock();
#endif
  point_edge = 0;
  edge_nbr = 0;

  BPnbr = LABELnbr = NEIGHnbr = LINEnbr = Enbr = SiteMax = 0;

  /* analysis of arguments */
  analyze_cline(argv,&ifargc,&ofargc);

  /* ѥ᡼ɽ
     displaying parameters */
  if(display_parameters == YES)
    dparam();
    
  /* ե륪ץ
     opening the output file */
  if((ofp = fopen(argv[ofargc],"w"))==NULL) {
    fprintf(stderr,"can't open output-file\n");
    exit(1);
  }

  /* reading image data */
  read_image(argv[ifargc],&imgd1);
    
  /* μ1 ʬ0 ˥åȤ.
     clearing the edge of the input image */
  frame(&imgd1,1,0);

  /* mallocs */
  bpx=(BlackPixel *)myalloc(sizeof(BlackPixel) * INITPIXEL);
  sites = (struct Site *) myalloc(SITE_BOX*sizeof *sites);
  component = (Component *)myalloc(sizeof(Component) * INITLABEL);

#ifdef TIME
  end = clock();
  etc_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif

  /* ϲSite Ѵ
     conversion of the input image to Site data */
  fprintf(stderr,"Transforming Image to Site...");
#ifdef TIME
  start = clock();
#endif
  img_to_site(&imgd1);
#ifdef TIME
  end = clock();
  b_s_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
  fprintf(stderr,"done\n");

#ifdef TIME
  start = clock();
#endif
  /* if you need sample points on boundaries of CC's */
  if(output_points == YES){
    fout_sites(nsites,ofp);
    fclose(ofp);
    exit(0);
  }

  /* component ͤ򥻥å
     setting values of connected components */
  set_component((Coordinate)(imgd1.imax-1),(Coordinate)(imgd1.jmax-1));

  free(bpx);
    
  neighbor = (Neighborhood *)myalloc(sizeof(Neighborhood)* INITNEIGHBOR);
  lineseg = (LineSegment *)myalloc(sizeof(LineSegment)* INITLINE);

  /* ϥåɽ
     initialization of hash tables */
  init_hash();

#ifdef TIME
  end = clock();
  etc_time += (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif

  /* ꥢVoronoi ޺
     construction of the area (or point) Voronoi diagram */
  fprintf(stderr,"Constructing the area Voronoi diagram...");
#ifdef TIME
  start = clock();
#endif
  voronoi(imgd1.imax, imgd1.jmax);
#ifdef TIME
  end = clock();
  v_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
  fprintf(stderr,"done\n");
#ifdef TIME
  start = clock();
#endif

  if(output_pvor == YES || output_avor == YES){
    fout_vor_edges(ofp);
    fclose(ofp);
    exit(0);
  }

  SiteMax++;
  endp = (EndPoint *)myalloc(sizeof(EndPoint) * SiteMax);

  /* ܥ neighbor_graph ΰݡ */
  init_neighbor_graph();

  /* neighbor[i].register ν */
  for(i=0;i<NEIGHnbr;i++){
    neighbor[i].regist = NOT_REGISTERED;
  }
    
  /* seed ΰݡ */
  init_seed();
    
  /* ccomponent_stat ν */
  init_ccomponent_stat();

#ifdef TIME
  end = clock();
  etc_time += (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif

  /* ɤȱĹ
     extraction and extension of seeds */
#ifdef TIME
  start = clock();
#endif
  erase();
#ifdef TIME
  end = clock();
  e_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif

  /* ʸ
     output of line segments representing textlines */
#ifdef TIME
  start = clock();
#endif
  if((YES == output_convexhull)||(YES == in_ch_line)){
    /* textline ΰ,  */
    init_textline();
    /* textline Υå */
    set_textline();
    /* textline[*].gravity Υå */
    /* ΤȤ */
    /* set_gravity(); */
  }
    
  if(YES == in_ch_line){
    regist_inside();
  }

  if(YES == output_convexhull){
    output_textline();
  }
  else{
    for(i=0;i<NEIGHnbr;i++) {
      if((neighbor[i].regist == REGISTERED) &&
	 (neighbor[i].lab1 != neighbor[i].lab2)&&
	 (component[neighbor[i].lab1].xc != component[neighbor[i].lab2].xc
	  ||component[neighbor[i].lab1].yc != component[neighbor[i].lab2].yc)){
	fprintf(ofp,"%d %d %d %d\n",
		component[neighbor[i].lab1].xc,component[neighbor[i].lab2].xc,
		component[neighbor[i].lab1].yc,component[neighbor[i].lab2].yc);
	edge_nbr++;
      }
    }
  }

#ifdef TIME
  end = clock();
  o_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif

#ifdef TIME
  start = clock();
#endif

  /* ե륯 */
  fclose(ofp);

  /* ΰ */
  free(sites);
  free_seed();
  free(lineseg);
  free(component);
  free(neighbor);
  free(imgd1.image);

  /* displaying statistics */
  dnumber(imgd1.imax,imgd1.jmax);
#ifdef TIME
  end = clock();
  etc_time += (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
#ifdef TIME
  /* displaying time */
  dtime();
#endif
  return(0);
}
