static char version_string[]="$Id: neighbor_graph.c,v 1.3 1999/10/15 12:36:21 kise Exp $";
/***************************************************************************
*   $Date: 1999/10/15 12:36:21 $                                           *
*   $Revision: 1.3 $                                                       *
*   $Author: kise $                                                        *
*                                                                          *
*   neighbor_graph.c                                                       *
*   ܥ neighbor_graph 򰷤ץ                             *
*   ܥ neighbor_graph[i] äƤΤ ٥ i Ϣʬ    *
*   ܴطɽ List ι¤ΤؤΥݥ(next)                     *
*   Ϣʬ鿭ӤޤΤ, ɤϿƤܿ(number)     *
*   List  neighbor ֹ, List ¤Τؤ                     *
*   ݥ󥿤.                                                      *
*   Ĥޤ, neighbor_graph[i] Ǥ ٥ i Ϣʬܴطɽ *
*   neighbor ֹä󥯥ȥꥹȤƬؤΥݥ󥿤Ǥ.         *
*   ---------------------------------------------------------------------- *
*   program neighbor_graph.c                                               *
*   This program is to deal with the neighbor graph.                       *
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "const.h"
#include "defs.h"
#include "extern.h"
#include "function.h"


List             *neighbor_graph;      /* ܥ
					  neighbor graph */
/*
 *  init_neighbor_graph
 *  neighbor_graph ΰݡؿ
 *  initialization of the neighbor graph
 */
void init_neighbor_graph()
{
  int i;

  /* ܥ neighbor_graph ΰ */
  neighbor_graph = (List *)myalloc(sizeof(List)* LABELnbr);

  /* neighbor_graph  */
  for(i=0;i<LABELnbr;i++){
    neighbor_graph[i].number = 0;
    neighbor_graph[i].next = NULL;
  }

}

/*
 *  make_neighbor_graph
 *  neighbor_graph ؿ
 *  Generation of the neighbor graph
 */
void make_neighbor_graph()
{
  unsigned int i;
  List *new_element1,*new_element2;

  /* neighbor  dist ξ˥ */
  qsort((void *)neighbor,NEIGHnbr,sizeof(Neighborhood),neighbor_compare);

  for(i=0;i<NEIGHnbr;i++){

    /* 󥯥ȥꥹȤΰ */
    new_element1 = (List *)myalloc(sizeof(List));
    new_element2 = (List *)myalloc(sizeof(List));
    
    (*new_element1).number = i;
    (*new_element2).number = i;
    
    (*new_element1).next = neighbor_graph[neighbor[i].lab1].next;
    (*new_element2).next = neighbor_graph[neighbor[i].lab2].next;
    
    neighbor_graph[neighbor[i].lab1].next = new_element1;
    neighbor_graph[neighbor[i].lab2].next = new_element2;
    
  }

}

/*
 *  peep_neighbor_graph
 *  ܥ neighbor_graph 򸫤ؿ
 *   : ϢʬΥ٥
 *  ֤ : Υ٥Ϣʬܴطɽ neighbor 
 *           ֹ椬ä󥯥ȥꥹȤƬǤؤΥݥ
 *  This function is to see the data in the neighbor graph.
 */
List* peep_neighbor_graph(Label label)
{
  return neighbor_graph[label].next;
}

/*
 *  inc_neighbor_graph
 *  ܥդ1Ǥ number 򥤥󥯥Ȥؿ
 *  Ϣʬ i 鿭ӤޤɤϿ줿˻Ȥ
 */
void inc_neighbor_graph(Label i)
{
  neighbor_graph[i].number++;
}

/*
 *  dec_neighbor_graph
 *  ܥդ1Ǥ number ǥȤؿ
 *  Ϣʬ i 鿭ӤޤɤϿ鳰줿˻Ȥ
 */
void dec_neighbor_graph(Label i)
{
  neighbor_graph[i].number--;
}

/*
 *  number_neighbor_graph
 *  Ϣʬ i 鿭ӤޤΤɤϿƤ֤ܿؿ
 */
unsigned int number_neighbor_graph(Label i)
{
  return neighbor_graph[i].number;
}

/*
 *  neighbor_compare
 *  åѴؿ
 */
int neighbor_compare(const void *a,const void *b)
{
  float i = (*(Neighborhood *)a).dist;
  float j = (*(Neighborhood *)b).dist;

  if(i > j){
    return 1;
  }
  else if(i < j){
    return -1;
  }
  else {
    return 0;
  }
	
}

/*
 *  free_neighbor_graph
 *  ܥ neighbor_graph ΰؿ
 */
void free_neighbor_graph()
{
  free(neighbor_graph);
}
