static char version_string[]="$Id: seed.c,v 1.4 1999/10/15 12:36:21 kise Exp $";
/******************************************************************
*   $Date: 1999/10/15 12:36:21 $                                  *
*   $Revision: 1.4 $                                              *
*   $Author: kise $                                               *
*                                                                 *
*   seed.c                                                        *
*   ɤħ Seed  seed 򰷤ץ                *
*                                                                 *
*   ɤαĹȽΤȤߤΥɤȽ                      *
*   ɤˡѹ                                          *
******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "defs.h"
#include "extern.h"
#include "function.h"

extern float            Td2;
extern float            Tds;

Seed                    *seed;        /* ɤħ */
unsigned int            SEEDnbr=0;    /* ɤθĿ  the number of seeds */
unsigned int            current_seed_size=0;

/*
 *  init_seed
 *  ɤΰݤӽԤؿ
 */
void init_seed()
{
  
  int i;

  /* ɤħseed ΰ */
  seed = (Seed *)myalloc(sizeof(Seed)* INITSEED);
  current_seed_size=INITSEED;

  /* seed  */
  for(i=0;i<INITSEED;i++){
    init_seed_aux(&seed[i]);
  }
}

void init_seed_aux(Seed *seedp)
{
  seedp->idlist = (unsigned int *)myalloc(sizeof(unsigned int) * INITID);
  seedp->current_idlist_size = INITID;
  init_idlist(seedp->idlist, 0, INITID);

  seedp->lablist = (Label *)myalloc(sizeof(Label) * INITSEEDELM);
  seedp->current_lablist_size = INITSEEDELM;
  init_lablist(seedp->lablist, 0, INITSEEDELM);

  seedp->start.id = UNSIGNED_MAX;
  seedp->start.label = LABELMAX;
  seedp->end.id = UNSIGNED_MAX;
  seedp->end.label = LABELMAX;
  seedp->mean_angle = 0;
  seedp->mean_dist = 0;
  seedp->dispersion_angle = 0;
  seedp->dispersion_dist = 0;
  seedp->extend = NO;
}

void init_idlist(unsigned int *idlist, int from, int to)
{
  int k;

  for(k=from;k<to;k++){
    idlist[k] = UNSIGNED_MAX;
  }
}

void init_lablist(Label *lablist, int from, int to)
{
  int k;

  for(k=from;k<to;k++){
    lablist[k] = LABELMAX;
  }
}

/*
 *  set_ratio
 *  neighbor[].*_ratio 򥻥åȤؿ
 */
void set_ratio()
{
  int i;
  unsigned int lab1, lab2;
  float lab1_area, lab2_area, area_ratio;
  float lab1_diameter, lab2_diameter, dia_ratio;
	
  for(i = 0; i < NEIGHnbr; i++){
    /* ܥդ neighbor ξüϢʬΥ٥ */
    lab1 = neighbor[i].lab1;
    lab2 = neighbor[i].lab2;
		
    /* Ϣʬ */
    lab1_area = component[lab1].area;
    lab2_area = component[lab2].area;
		
    /* Ϣʬľ */
    lab1_diameter = component[lab1].diameter;
    lab2_diameter = component[lab2].diameter;
		
    if(lab1_area <= lab2_area){
      /* Ϣʬlab1 Ϣʬlab2 꾮 */
      area_ratio = lab1_area/lab2_area;
    }
    else{
      /* Ϣʬlab2 Ϣʬlab1 꾮 */
      area_ratio = lab2_area/lab1_area;
    }
		
    neighbor[i].area_ratio = area_ratio;

    if(lab1_diameter <= lab2_diameter){
      dia_ratio = lab1_diameter/lab2_diameter;
    }
    else{
      dia_ratio = lab2_diameter/lab1_diameter;
    }
		
    neighbor[i].dia_ratio = dia_ratio;
  }
}

/*
 *  make_seed
 *  ɤؿ
 *
 *  erase.c ǤȤʤ
 */
void make_seed()
{
  unsigned int i,j,k;
  unsigned int lab1,lab2,lab1_seednum,lab2_seednum,filnum;
  float dist, dia_ratio, area_ratio;

  /* Ϣʬɤ˴ޤޤƤ뤫ɤ 
     this array represents whether a connected component
     is included in a seed */
  char condition[LABELnbr];

  /* condition ν */
  for(i=0;i<LABELnbr;i++){
    condition[i] = NO;
  }

  for(i=0;i<NEIGHnbr;i++){
		
    /* ܥդ neighbor ξüϢʬΥ٥ */
    lab1 = neighbor[i].lab1;
    lab2 = neighbor[i].lab2;
		
    /* Ϣʬ֤ħ */
    dist = neighbor[i].dist;
    area_ratio = neighbor[i].area_ratio;
    dia_ratio = neighbor[i].dia_ratio;
		
    if(neighbor[i].dist > Tds){
      break;
    }
    else if((area_ratio > t_area)&&(dia_ratio > t_dia)
	    &&(!((condition[lab1]==YES)&&(condition[lab2]==YES)))){

      /* neighbor[i] 򥷡ɤǤˤ */
      neighbor[i].regist = REGISTERED;
      condition[lab1] = YES;
      condition[lab2] = YES;
			
      inc_neighbor_graph(lab1);
      inc_neighbor_graph(lab2);
			
      lab1_seednum = peep_ccomponent_stat(neighbor[i].lab1);
      lab2_seednum = peep_ccomponent_stat(neighbor[i].lab2);
			
      if((lab1_seednum == UNSIGNED_MAX)&&(lab2_seednum == UNSIGNED_MAX)){
	/* lab1,lab2 ˥ɤϿƤʤ */
	seed[SEEDnbr].lablist[0] = lab1;
	seed[SEEDnbr].lablist[1] = lab2;
	seed[SEEDnbr].idlist[0] = i;
	seed[SEEDnbr].noe = 1;
	seed[SEEDnbr].labnoe = 2;
	set_ccomponent_stat(lab1,SEEDnbr);
	set_ccomponent_stat(lab2,SEEDnbr);
	SEEDnbr++;
	if(SEEDnbr >= current_seed_size) {
	  seed=(Seed *)myrealloc(seed, current_seed_size,
				 INCSEED, sizeof(Seed));
	  for(j=current_seed_size;j<current_seed_size+INCSEED;j++){
	    init_seed_aux(&seed[j]);
	  }
	  current_seed_size+=INCSEED;
	}
      }
      else if((lab1_seednum != UNSIGNED_MAX)&&(lab2_seednum != UNSIGNED_MAX)){
	/* lab1,lab2 Ȥ˥ɤϿƤ */
	if(lab1_seednum != lab2_seednum){
	  seed[lab1_seednum].idlist[seed[lab1_seednum].noe] = i;
	  seed[lab1_seednum].noe++;
	  resize_idlist(&seed[lab1_seednum]);
	  for(j=0;j<seed[lab2_seednum].labnoe;j++){
	    seed[lab1_seednum].lablist[seed[lab1_seednum].labnoe]
	      = seed[lab2_seednum].lablist[j];
	    seed[lab1_seednum].labnoe++;
	    resize_lablist(&seed[lab1_seednum]);
	    set_ccomponent_stat(seed[lab2_seednum].lablist[j],lab1_seednum);
	  }
	  for(j=0;j<seed[lab2_seednum].noe;j++){
	    seed[lab1_seednum].idlist[seed[lab1_seednum].noe]
	      = seed[lab2_seednum].idlist[j];
	    seed[lab1_seednum].noe++;
	    resize_idlist(&seed[lab1_seednum]);
	  }
	  /* lab2_seednum ¦ΥɤˤϤ⤦ʤ */
	  seed[lab2_seednum].labnoe = 0;
	  seed[lab2_seednum].noe =0;
	}
	else{
	  seed[lab1_seednum].idlist[seed[lab1_seednum].noe] = i;
	  seed[lab1_seednum].noe++;
	  resize_idlist(&seed[lab1_seednum]);
	}
      }
      else if(lab1_seednum != UNSIGNED_MAX){
	/* lab1  lab1_seednum ܤΥɤϿƤ */
	seed[lab1_seednum].lablist[seed[lab1_seednum].labnoe] = lab2;
	seed[lab1_seednum].labnoe++;
	resize_lablist(&seed[lab1_seednum]);
	seed[lab1_seednum].idlist[seed[lab1_seednum].noe] = i;
	seed[lab1_seednum].noe++;
	resize_idlist(&seed[lab1_seednum]);
	set_ccomponent_stat(lab2,lab1_seednum);
      }
      else if(lab2_seednum != UNSIGNED_MAX){
	/* lab2  lab2_seednum ܤΥɤϿƤ */
	seed[lab2_seednum].lablist[seed[lab2_seednum].labnoe] = lab1;
	seed[lab2_seednum].labnoe++;
	resize_lablist(&seed[lab2_seednum]);
	seed[lab2_seednum].idlist[seed[lab2_seednum].noe] = i;
	seed[lab2_seednum].noe++;
	resize_idlist(&seed[lab2_seednum]);
	set_ccomponent_stat(lab1,lab2_seednum);
      }
    }
  }

  /* ʬΤ륷ɤ1Ĥλޤʤ륷ɤե륿
     deletion of seeds which include either a branch or a loop
     as well as consist of a single edge
     */
  for(i=0;i<SEEDnbr;i++){
    /* 1Ĥλޤʤ륷ɤ⤷ϥ롼פΤ륷*/
    if((seed[i].noe == 1)||(seed[i].noe == seed[i].labnoe)){
      for(j=0;j<seed[i].noe;j++){
	filnum = seed[i].idlist[j];
	neighbor[filnum].regist = NOT_REGISTERED;
	dec_neighbor_graph(neighbor[filnum].lab1);
	dec_neighbor_graph(neighbor[filnum].lab2);
	seed[i].idlist[j] = UNSIGNED_MAX;
      }
      for(j=0;j<seed[i].labnoe;j++){
	set_ccomponent_stat(seed[i].lablist[j],UNSIGNED_MAX);
	seed[i].lablist[j] = LABELMAX;
      }
      seed[i].noe = 0;
      seed[i].labnoe = 0;
    }			
    else{
      for(k=0;k<seed[i].labnoe;k++){
	/* ʬΤ륷 */
	if(number_neighbor_graph(seed[i].lablist[k]) > 2){
	  /* fprintf(stderr,"bunki! seed[%d].noe = %d\n",i,seed[i].noe);*/
	  for(j=0;j<seed[i].noe;j++){
	    filnum = seed[i].idlist[j];
	    neighbor[filnum].regist = NOT_REGISTERED;
	    dec_neighbor_graph(neighbor[filnum].lab1);
	    dec_neighbor_graph(neighbor[filnum].lab2);
	    seed[i].idlist[j] = UNSIGNED_MAX;
	  }
	  for(j=0;j<seed[i].labnoe;j++){
	    set_ccomponent_stat(seed[i].lablist[j],UNSIGNED_MAX);
	    seed[i].lablist[j] = LABELMAX;
	  }
	  seed[i].noe = 0;
	  seed[i].labnoe = 0;
					
	  break;
	}
      }
    }
  }		

  /* ɤξüΥå */
  /* Υʿѡʬ׻ */
  for(i=0;i<SEEDnbr;i++){
    if(seed[i].noe != 0){
      tipset(i);         /* setting ends of a seed */
      element_calc(i);   /* calculating ave. and var. of
			    the distance and angles */ 
    }
  }

  /* Ŭʥɤե륿
     deletion of inappropriate seeds */
  for(i=0;i<SEEDnbr;i++){
    if((seed[i].dispersion_angle > angle_filter)||
       (seed[i].dispersion_dist > dist_filter)){
      /* ɤγ٤ʬ angle_filter ʾ
	 ɤεΥʬ dist_filter ʾΥɸ */
      for(j=0;j<seed[i].noe;j++){
	filnum = seed[i].idlist[j];
	neighbor[filnum].regist = NOT_REGISTERED;
	dec_neighbor_graph(neighbor[filnum].lab1);
	dec_neighbor_graph(neighbor[filnum].lab2);
	seed[i].idlist[j] = UNSIGNED_MAX;
      }
      for(j=0;j<seed[i].labnoe;j++){
	set_ccomponent_stat(seed[i].lablist[j],UNSIGNED_MAX);
	seed[i].lablist[j] = LABELMAX;
      }
      seed[i].noe = 0;
      seed[i].labnoe = 0;
    }
  }

}

void resize_idlist(Seed *seedp)
{
  if(seedp->noe >= seedp->current_idlist_size){
    seedp->idlist = (unsigned int *)myrealloc(seedp->idlist,
					      seedp->current_idlist_size,
					      INCID,
					      sizeof(unsigned int));
    init_idlist(seedp->idlist,
		seedp->current_idlist_size,
		seedp->current_idlist_size+INCID);
    seedp->current_idlist_size+=INCID;
  }
}

void resize_lablist(Seed *seedp)
{
  if(seedp->labnoe >= seedp->current_lablist_size){
    seedp->lablist = (Label *)myrealloc(seedp->lablist,
					seedp->current_lablist_size,
					INCSEEDELM,
					sizeof(Label));
    init_lablist(seedp->lablist,
		 seedp->current_lablist_size,
		 seedp->current_lablist_size+INCSEEDELM);
    seedp->current_lablist_size+=INCSEEDELM;
  }
}

/*
 *  tipset
 *  i ܤΥɤκξüϢʬֹ򥻥åȤؿ
 *  κݤ idlist ¤ӽ˥Ȥ
 */
void tipset(unsigned int i)
{
  unsigned int j;
  unsigned int tmpid,count;
  unsigned int branch_num,id;
  Label minlab,maxlab,tmplab;
  Label label,lab1,lab2;
	
  minlab = LABELMAX;
  maxlab = LABELMAX;

  for(j=0;j<seed[i].labnoe;j++){
    label = seed[i].lablist[j];
    /* seed[i].lablist[j] 鿭ӤƤ륷ɤǤܿĴ٤ */
    branch_num = number_neighbor_graph(label);
    /* ⤷ seed[i].lablist[j] ɤüä */
    if(branch_num == 1){
      if(minlab == LABELMAX){
	minlab = label;
      }
      else if(component[label].xc <= component[minlab].xc){
	maxlab = minlab;
	minlab = label;
      }
      else if(component[label].xc > component[minlab].xc){
	maxlab = label;
      }
      else{
	fprintf(stderr,"tipset BUG case 1 !!!\n");
      }
    }
  }
  if((minlab==LABELMAX)||(maxlab==LABELMAX)){
    fprintf(stderr,"tipset bug is occurred in seed[%d]. \n",i);
  }
  tmplab = minlab;
  count = 0;
  for(j=0;j<seed[i].noe;j++){
    id = seed[i].idlist[j];
    lab1 = neighbor[id].lab1;
    lab2 = neighbor[id].lab2;
    if(lab1 == tmplab){
      tmpid = seed[i].idlist[count];
      seed[i].idlist[count] = id;
      seed[i].idlist[j] = tmpid;
      tmplab = lab2;
      j = count;
      count++;
    }
    else if(lab2 == tmplab){
      tmpid = seed[i].idlist[count];
      seed[i].idlist[count] = id;
      seed[i].idlist[j] = tmpid;
      tmplab = lab1;
      j = count;
      count++;
    }
  }
	
  seed[i].start.id = seed[i].idlist[0];
  seed[i].end.id = seed[i].idlist[seed[i].noe-1];
  seed[i].start.label = minlab;
  seed[i].end.label = maxlab;

}

/*
 *  element_calc
 *  ɤǤεΥʿѡʬ׻ؿ
 *  Ϸ׻Ԥɤֹ
 *  ɤηϻȽ֥٥ȥη
 */
void element_calc(unsigned int seednum)
{
  int i;
  unsigned int number, start, end;
  Label lab1, lab2, label;
  double dx,dy;
  float m_angle = 0,m_dist = 0,d_angle = 0,d_dist = 0,angle;
  int noe, labnoe;
  float m_area = 0, m_dia = 0;
	
  start = seed[seednum].start.label;
  end = seed[seednum].end.label;

  noe = seed[seednum].noe;
  labnoe = seed[seednum].labnoe;

  dx = (double)(component[end].xc - component[start].xc);
  dy = (double)(component[end].yc - component[start].yc);
  seed[seednum].mean_angle = (float)(atan2(dy,dx)*2*RIGHTANGLE/M_PI);

  for(i = 0; i < labnoe; i++){
    label = seed[seednum].lablist[i];
    m_area += component[label].area;
    m_dia += component[label].diameter;
  }
	
  seed[seednum].mean_area = m_area / labnoe;
  seed[seednum].mean_dia = m_dia / labnoe;
	
  for(i=0;i<noe;i++){
    number = seed[seednum].idlist[i];
    lab1 = neighbor[number].lab1;
    lab2 = neighbor[number].lab2;

    if(lab1 == start){
      dx = (double)(component[lab2].xc - component[lab1].xc);
      dy = (double)(component[lab2].yc - component[lab1].yc);
      start = lab2;
    }
    else if(lab2 == start){
      dx = (double)(component[lab1].xc - component[lab2].xc);
      dy = (double)(component[lab1].yc - component[lab2].yc);
      start = lab1;
    }
    else{
      fprintf(stderr,"element calc bug in seed[%d]. \n",seednum);
    }

    angle = (float)(atan2(dy,dx)*2*RIGHTANGLE/M_PI);
    m_angle += angle;
    d_angle += angle*angle;
		
    m_dist += neighbor[number].dist;
    d_dist += (neighbor[number].dist)*(neighbor[number].dist);		
  }
	
  m_angle = m_angle/(float)noe;
  m_dist = m_dist/(float)noe;
	
  d_angle = d_angle/(float)noe; /* λǤ d_angle  angle 2ʿ */
  d_dist = d_dist/(float)noe; /* λǤ d_dist  dist  2ʿ */
	
  d_angle = d_angle - m_angle*m_angle; /* d_angle  angle ʬ */
  d_dist = d_dist - m_dist*m_dist; /* d_dist  dist ʬ */
	
  seed[seednum].mean_dist = m_dist;
  seed[seednum].dispersion_angle = d_angle;
  seed[seednum].dispersion_dist = d_dist;
}

/*
 *  select_branch
 *  ĹȽԤޤִؿ
 */
void select_branch(unsigned int *apt, unsigned int seednum, char flag)
{
  Label slab=LABELMAX;
  Label exlab=LABELMAX;
  Label lab1,lab2;
  unsigned int branch,stat;
  unsigned int number;
  float area_ratio, dia_ratio, s_angle, angle_err;
  double dx,dy,theta,norum;
  List *read;
  float min_err[aptnbr];
  int i, j;

  for(i = 0; i < aptnbr; i++){
    apt[i] = UNSIGNED_MAX;
    min_err[i] = UNSIGNED_MAX;
  }
	
  if(flag == START){
    slab = seed[seednum].start.label;
    s_angle = seed[seednum].mean_angle;
    if(s_angle > 0){
      s_angle -= 2*RIGHTANGLE;
    }
    else{
      s_angle += 2*RIGHTANGLE;
    }
  }
  else if(flag == END){
    slab = seed[seednum].end.label;
    s_angle = seed[seednum].mean_angle;
  }

  if(slab==LABELMAX){
    fprintf(stderr,"slab uninitialized!!\n");
    exit(0);
  }
  else{
    read = peep_neighbor_graph(slab);
  }
	
  /* ɤü鿭ӤޤΤ,
     ٤2ǾȤʤ neighbor  */
  while(read != NULL){
    number = read->number;
    if(neighbor[number].regist == NOT_REGISTERED){
      lab1 = neighbor[number].lab1;
      lab2 = neighbor[number].lab2;
			
      /* lab1  lab2 Τɤ餬ĹϢʬĴ٤ */
      if(lab1 == slab){
	exlab = lab2;
      }
      else if(lab2 == slab){
	exlab = lab1;
      }
      else{
	fprintf(stderr,"slab is none!\n");
	fprintf(stderr,"lab1=%d, lab2=%d, slab=%d\n",lab1,lab2,slab);
      }

      if(exlab==LABELMAX){
	fprintf(stderr,"exlab uninitialized!!\n");
	exit(0);
      }
      else{
	branch = number_neighbor_graph(exlab);
	stat = peep_ccomponent_stat(exlab);
      }

      area_ratio = neighbor[number].area_ratio;
      dia_ratio = neighbor[number].dia_ratio;
			
      /* ɤ˲äʬΤȽꤷʤ */
      /* ƱɤˤƱĹ뤳Ȥ⤷ʤ */
      /* Ѥ(<1)  AREA_RATIO ʲλޤϽ */

      if((branch < 2)&&(stat != seednum)&&
	 (area_ratio > t_area)&&(dia_ratio > t_dia)){
	/* Ĺλޤ٥ȥ */
	dx = (double)(component[exlab].xc - component[slab].xc);
	dy = (double)(component[exlab].yc - component[slab].yc);
	norum = sqrt(dx*dx + dy*dy);
	/* s_angle 饸ľ */
	theta = (double)(s_angle*M_PI/(2*RIGHTANGLE));
				
	angle_err = (float)(acos((dx*cos(theta)+dy*sin(theta))/norum)
			    *2*RIGHTANGLE/M_PI);
				
	for(i = 0; i < aptnbr; i++){
	  if(angle_err < min_err[i]){
	    for(j = aptnbr-2; j >= i; j--){
	      apt[j+1] = apt[j];
	      min_err[j+1] = min_err[j];
	    }
						
	    min_err[i] = angle_err;
	    apt[i] = number;
						
	    break;
	  }
	}
      }
    }
    read = read->next;
  }
}

/*
 *  judge
 *  ޤĹξƤбĹԤؿ
 *  ĹȤ YES, ƤʤȤ NO ֤
 */
int judge(unsigned int neinum, unsigned int sdnum, char flag,int time)
{
  char checker=MIDDLE;
  int j, k;
  Label slab=LABELMAX;
  Label exlab=LABELMAX;
  Label lab1,lab2;
  unsigned int exlab_stat;
  float angle_err,dist_err,s_angle,s_dist,n_dist;
  double dx,dy,theta,norum;
  float second_angle,second_dist;
  unsigned int *apt;
	
  if(flag == START){
    slab = seed[sdnum].start.label;
    s_angle = seed[sdnum].mean_angle;
    if(s_angle > 0){
      s_angle -= 2*RIGHTANGLE;
    }
    else{
      s_angle += 2*RIGHTANGLE;
    }
  }
  else if(flag == END){
    slab = seed[sdnum].end.label;
    s_angle = seed[sdnum].mean_angle;
  }
  lab1 = neighbor[neinum].lab1;
  lab2 = neighbor[neinum].lab2;
  
  if(lab1 == slab){
    exlab = lab2;
  }
  else if(lab2 == slab){
    exlab = lab1;
  }
  
  if(slab==LABELMAX || exlab==LABELMAX){
    fprintf(stderr,"slab or exlab uninitialized!!\n");
    exit(0);
  }
  else{
    /* ĹλޤΥ٥ȥ */
    dx = (double)(component[exlab].xc - component[slab].xc);
    dy = (double)(component[exlab].yc - component[slab].yc);
  }
  norum = sqrt(dx*dx + dy*dy);
  /* s_angle 饸ľ */
  theta = (double)(s_angle*M_PI/(2*RIGHTANGLE));
  
  /* ɤΥ٥ȥȻޤΥ٥ȥȤ */
  angle_err = (float)(acos((dx*cos(theta)+dy*sin(theta))/norum)
		      *2*RIGHTANGLE/M_PI);
  
  n_dist = neighbor[neinum].dist;
  s_dist = seed[sdnum].mean_dist;
  
  /* Υ2Ȥ */
  dist_err = (n_dist - s_dist)*(n_dist - s_dist);
  
  /* ĹξȽ */
  if(angle_err/(c_theta*time/looptimes) + dist_err/c_dist <= 1){ /* ľ */
		
    exlab_stat = peep_ccomponent_stat(exlab);
		
    if(exlab_stat == UNSIGNED_MAX){

      /* Ĺ褬ɤ˴ޤޤƤʤ */
      seed[sdnum].extend = YES;
			
      seed[sdnum].idlist[seed[sdnum].noe] = neinum;
      seed[sdnum].noe++;
      resize_idlist(&seed[sdnum]);
			
      neighbor[neinum].regist = REGISTERED;
      inc_neighbor_graph(slab);
      inc_neighbor_graph(exlab);
			
      seed[sdnum].lablist[seed[sdnum].labnoe] = exlab;
      seed[sdnum].labnoe++;
      resize_lablist(&seed[sdnum]);
      set_ccomponent_stat(exlab,sdnum);

      return YES;
    }
    else if(exlab_stat == sdnum){
      /* lab1,lab2 Ȥ seed[i] ǤǤ */
      fprintf(stderr,"simlar element in seed[%d] \n",sdnum);
      return YES;
    }
    else if(exlab_stat != UNSIGNED_MAX){
      /* Ĺ褬¾ΥɤǤǤ */
      /* ΥɤĹȽԤ */
      if(exlab == seed[exlab_stat].start.label){
	second_angle = seed[exlab_stat].mean_angle;
	if(second_angle > 0){
	  second_angle -= 2*RIGHTANGLE;
	}
	else{
	  second_angle += 2*RIGHTANGLE;
	}
	checker = START;
      }
      else if(exlab == seed[exlab_stat].end.label){
	second_angle = seed[exlab_stat].mean_angle;
	checker = END;
      }

      /* apt ΰ */
      apt = (unsigned int *)myalloc(sizeof(unsigned int)* aptnbr);

      if(checker!=MIDDLE){
	select_branch(apt, exlab_stat, checker);
      }
      else{
	fprintf(stderr,"checker uninitialized!!\n");
	exit(0);
      }
			
      for(k = 0; k < aptnbr; k++){
	if((apt[k] != UNSIGNED_MAX)&&(neinum == apt[k])){
			
	  /* ĹλޤΥ٥ȥ */
	  dx = (double)(component[slab].xc - component[exlab].xc);
	  dy = (double)(component[slab].yc - component[exlab].yc);
	  norum = sqrt(dx*dx + dy*dy);
	  /* second_angle 饸ľ */
	  theta = (double)(second_angle*M_PI/(2*RIGHTANGLE));
			
	  /* ɤΥ٥ȥȻޤΥ٥ȥȤ */
	  angle_err = (float)(acos((dx*cos(theta)+dy*sin(theta))/norum)
			      *2*RIGHTANGLE/M_PI);
			
	  n_dist = neighbor[neinum].dist;
	  second_dist = seed[exlab_stat].mean_dist;
			
	  /* Υ2Ȥ */
	  dist_err = (n_dist - second_dist)*(n_dist - second_dist);
			
	  /* پȽ */
	  if(angle_err/(c_theta*time/looptimes)
	     + dist_err/c_dist <= 1){ /* ľ */

	    seed[sdnum].extend = YES;
				
	    seed[sdnum].idlist[seed[sdnum].noe] = neinum;
	    seed[sdnum].noe++;
	    resize_idlist(&seed[sdnum]);
				
	    neighbor[neinum].regist = REGISTERED;
	    inc_neighbor_graph(slab);
	    inc_neighbor_graph(exlab);
				
	    for(j=0;j<seed[exlab_stat].labnoe;j++){
	      seed[sdnum].lablist[seed[sdnum].labnoe]
		= seed[exlab_stat].lablist[j];
	      set_ccomponent_stat(seed[exlab_stat].lablist[j],sdnum);
	      seed[sdnum].labnoe++;
	      resize_lablist(&seed[sdnum]);
	    }
	    for(j=0;j<seed[exlab_stat].noe;j++){
	      seed[sdnum].idlist[seed[sdnum].noe]
		= seed[exlab_stat].idlist[j];
	      seed[sdnum].noe++;
	      resize_idlist(&seed[sdnum]);
	    }
	    seed[exlab_stat].noe = 0;
	    seed[exlab_stat].labnoe = 0;
	    seed[exlab_stat].extend = NO;

	    return YES;
	  }
	}
      }
      free(apt);
    }
  }

  return NO;
}


/*
 *  extend_seed
 *  ɤαĹԤؿ
 */
void extend_seed()
{
  unsigned int i, j, k; /* 롼 */
  unsigned int old_noe, *min_neighbor;
  int extend;

  /* ɤ򥷡ɤǿ¿˥ */
  /*qsort((void*)seed,SEEDnbr,sizeof(Seed),compare);*/
	
  /* Ȥ seed ֹ椬ѤΤ, ccomponent_stat 򥻥åȤʤ */
  /*for(i=0;i<SEEDnbr;i++){*/
  /* seed[i].labnoe  0 ΤΤϥ롼פʤ */
  /*for(j=0;j<seed[i].labnoe;j++){
    set_ccomponent_stat(seed[i].lablist[j],i);
    }
  }*/

  /* c_dist ưꤹͤ򥻥å */
  if(cdist_is_auto == YES){
    c_dist = Td2*Td2;
  }
	
  /* min_neighbor ΰ */
  min_neighbor = (unsigned int *)myalloc(sizeof(unsigned int)* aptnbr);

  /* Ƚˤʤ looptimes 롼פޤ魯 */
  for(j=1;j<=looptimes;j++){
    for(i=0;i<SEEDnbr;i++){
      old_noe = 0;
      /* seed[i].noe  0 ΤΤϥ롼פʤ */
      while(seed[i].noe != old_noe){
	old_noe = seed[i].noe;
			
	/* START ΥɱĹȽ */
	select_branch(min_neighbor, i, START);
	for(k = 0; k < aptnbr; k++){
	  if(min_neighbor[k] != UNSIGNED_MAX){
	    extend = judge(min_neighbor[k],i,START,j);

	    if(extend == YES){
	      break;
	    }
	  }
	}
				
	/* END ΥɱĹȽ */
	select_branch(min_neighbor, i, END);
	for(k = 0; k < aptnbr; k++){
	  if(min_neighbor[k] != UNSIGNED_MAX){
	    extend = judge(min_neighbor[k],i,END,j);

	    if(extend == YES){
	      break;
	    }
	  }
	}
			
	/* ɤħ̤׻ľ */
	tipset(i);
	element_calc(i);
      }
    }
  }
	
  free(min_neighbor);

  /* Ǥο minnoe ̤ΥɤΤƤ */
  for(i=0;i<SEEDnbr;i++){
    if(seed[i].noe < minnoe){
      for(j=0;j<seed[i].noe;j++){
	neighbor[seed[i].idlist[j]].regist = NOT_REGISTERED;
      }
    }
  }
}

/*
 *  compare
 *  åѴؿ
 */
/*
int compare(const void *a,const void *b)
{
  int i = (*(Seed *)a).noe;
  int j = (*(Seed *)b).noe;

  if(i < j){
    return 1;
  }
  else if(i > j){
    return -1;
  }
  else {
    return 0;
  }
}
*/

/*
 *  free_seed
 *   seed ΰؿ
 */
void free_seed()
{
  free(seed);
}

/*
 *  lablist_of_seed
 *  ֤ :  i ܤϢʬΥ٥
 */
Label lablist_of_seed(int seednum, int i)
{
  return seed[seednum].lablist[i];
}

/*
 *  labnoe_of_seed
 *  ֤ : ɤϢʬο
 */
Label labnoe_of_seed(int seednum)
{
  return seed[seednum].labnoe;
}

/*
 *  number_of_seed
 *  ɤο֤ؿ
 */
int number_of_seed()
{
  int   i;
  int   number = 0;

  for(i = 0; i < SEEDnbr; i++){
    if(seed[i].noe != 0){
      number++;
    }
  }
  return number;
}

/*
 *  set_textline
 *  textline Υå
 */
void set_textline()
{
  int i;
  int textnbr = 0;

  for(i = 0; i < SEEDnbr; i++){
    if(seed[i].noe != 0){
      convex_hull_of_line(i, textnbr);
      textnbr++;
    }
  }
}
